# The Torrust Contributor Agreement

<!-- markdownlint-disable MD013 -->

[Version 2021-11-10]

## Goal

We require that contributors to Torrust (as defined below) agree to this Torrust Contributor Agreement (NCCA) to ensure that contributions to Torrust have acceptable licensing terms.

## Non-Goals

The NCCA is _not_ a copyright assignment agreement.

The NCCA does _not_ somehow supersede the existing licensing terms that apply to Torrust contributions. There are two important subpoints here. First, the NCCA does not apply to upstream code (or other material) that you didn't write; indeed, it would be preposterous for it to attempt to do so. Note the narrow way in which we have defined capital-c "Contribution".

Second, the main provision of the NCCA specifies that a default license will apply to code that you wrote, but only to the extent that you have not bothered to put an explicit license on it. Therefore, the NCCA is _not_ some sort of special permissive license granted to any party, despite the explicit choice of a more restrictive license by you or by upstream developers.

## Terms

### Section 1 – Definitions

__"Acceptable License For Torrust"__ means a license selected from the appropriate categorical sublist of the full list of acceptable licenses for Torrust, currently located at <https://github.com/Torrust/Torrust-librarian/tree/main/licensing>, as that list may be revised from time to time by Torrust. "Acceptable Licenses For Torrust" means that full list.

__"AGPLv3"__ means the license identified as "Affero General Public License 3.0", as published at <https://www.gnu.org/licenses/agpl-3.0.en.html>.

__"CC-0"__ means the Creative Commons 1.0 Universal license, as published at <https://creativecommons.org/publicdomain/zero/1.0/legalcode>.

__"CC-BY-SA"__ means the Creative Commons Attribution-ShareAlike 4.0 International license, as published at <https://creativecommons.org/licenses/by-sa/4.0/legalcode>.

__"Code"__ means (i) software code, (ii) any other functional material whose principal purpose is to control or facilitate the building of packages, such as an RPM spec file, (iii) font files, and (iv) other kinds of copyrightable material that the Torrust has classified as "code" rather than "content".

__"Content"__ means any copyrightable material that is not Code, such as, without limitation, (i) non-functional data sets, (ii) documentation, (iii) wiki edits, (iv) music files, (v) graphic image files, (vi) help files, and (vii) other kinds of copyrightable material that the Torrust Council has classified as "content" rather than "code".

__"Contribution"__ means a Work that You created, excluding any portion that was created by someone else. (For example, if You Submit a package to Torrust, the spec file You write may be a Contribution, but all the upstream code in the associated Package that You did not write is not a Contribution for purposes of this NCCA.) A Contribution consists either of Code or of Content.

__"Current Default License"__, with respect to a Contribution, means (i) if the Contribution is Code, the AGPLv3 License, and (ii) if the Contribution is Content, CC-BY-SA.

__"Future Public Domain License"__, with respect to a Contribution, means (i) if the Contribution is Code, the MIT-0 License, and (ii) if the Contribution is Content, CC-0.

__"Licensed"__ means covered by explicit licensing terms that are conspicuous and readily discernible to recipients.
"Submit" means to use some mode of digital communication (for example, without limitation, mailing lists, bug tracking systems, and source code version control systems administered by Torrust) to voluntarily provide a Contribution to Torrust.
"Unlicensed" means not Licensed.

__"MIT-0"__ means the license identified as "MIT No Attribution", as published at <https://opensource.org/licenses/MIT-0>.

__"Torrust"__ means the community project led by the Torrust <https://torrust.com/>.
"Torrust Community" means (i) all Torrust participants, and (ii) all persons receiving Contributions directly or indirectly from or through Torrust.

__"Work"__ means a copyrightable work of authorship. A Work may be a portion of a larger Work, and a Work may be a modification of or addition to another Work.  "You" means the individual accepting this instance of the NCCA.

### Section 2 – List of Acceptable Licenses for Torrust

- CC-BY-SA
- CC-0
- AGPLv3
- MIT-0

### Section 3 – Copyright Permission Required for All Contributions

If You are not the copyright holder of a given Contribution that You wish to Submit to Torrust (for example, if Your employer or university holds copyright in it), it is Your responsibility to first obtain authorization from the copyright holder to Submit the Contribution under the terms of this NCCA on behalf of, or otherwise with the permission of, that copyright holder. One form of such authorization is for the copyright holder to place, or permit You to place, an Acceptable License For Torrust on the Contribution.

### Section 4 – Licensed Contributions

If Your Contribution is Licensed, Your Contribution will be governed by the terms under which it has been licensed.

### Section 5 – Default Licensing of Unlicensed Contributions

If You Submit an Unlicensed Contribution to Torrust, the license to the Torrust Community for that Contribution shall be the Current Default License.

The Torrust may, by public announcement, subsequently designate an additional or alternative default license for a given category of Contribution (a "Later Default License"). A Later Default License shall be chosen from the appropriate categorical sublist of Acceptable Licenses For Torrust.
Once a Later Default License has been designated, Your Unlicensed Contribution shall also be licensed to the Torrust Community under that Later Default License. Such designation shall not affect the continuing applicability of the Current Default License to Your Contribution.

You consent to having Torrust provide reasonable notice of Your licensing of Your Contribution under the Current Default License (and, if applicable, a Later Default License) in a manner determined by Torrust.

### Section 6 – Automatic Future Public Domain License

You consent that your contribution under the Current Default License is granted the Future Public Domain License __automatically__ after 5 years of submission.

### Section 7 – Public Domain United States Government Works

Sections 3 through 6 of this NCCA do not apply to any Contribution to the extent that it is a work of the United States Government for which copyright is unavailable under 17 U.S.C. 105.

### Section 8 – Acceptance

You must signify Your assent to the terms of this NCCA through specific electronic means established by Torrust.

You may also, at Your option, and without eliminating the requirement set forth in the preceding paragraph, send a copy of this NCCA, bearing Your written signature indicating Your acceptance of its terms, by email to legal@torrust.com, or by postal mail to:

    Torrust Legal
    c/o Nautilus Cyberneering GmbH
    Oberhachingerstr. 46B
    2031 Grünwald
    Germany

### Section 9 – Notes

This document is based upon:

[The Fedora Project Contributor Agreement](https://fedoraproject.org/w/index.php?title=Legal:Fedora_Project_Contributor_Agreement&oldid=629385).  
[Version 2021-05-04]

<!-- markdownlint-enable MD013 -->
